<?php
/**
 * Registering meta boxes
 *
 * All the definitions of meta boxes are listed below with comments.
 * Please read them CAREFULLY.
 *
 * You also should read the changelog to know what has been changed before updating.
 *
 * For more information, please visit:
 * @link http://metabox.io/docs/registering-meta-boxes/
 */
add_filter( 'rwmb_meta_boxes', 'your_prefix_register_meta_boxes' );
/**
 * Register meta boxes
 *
 * Remember to change "your_prefix" to actual prefix in your project
 *
 * @param array $meta_boxes List of meta boxes
 *
 * @return array
 */
function your_prefix_register_meta_boxes( $meta_boxes )
{
	/**
	 * prefix of meta keys (optional)
	 * Use underscore (_) at the beginning to make keys hidden
	 * Alt.: You also can make prefix empty to disable it
	 */
	// Better has an underscore as last sign
	$prefix = 'rs_';
	// 1st meta box
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'standard',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Standard Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('product'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// TEXT
			array(
				'name'  => __( 'Dynamic-Qr-Code', 'rs_' ),
				'id'    => "{$prefix}dynamicqrcode",
				'type'  => 'number',
			),
            array(
				'name'  => __( 'Scan', 'rs_' ),
				'id'    => "{$prefix}scan",
				'type'  => 'number',
			),
            
			
		)
	);
	
	
	
		$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'standard',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Standard Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('whyus'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// Special Content
			array(
				'name'  => __( 'whypoint1', 'rs_' ),
				'id'    => "{$prefix}whypoint1",
				'type'  => 'text',
			),
            array(
				'name'  => __( 'whypoint2', 'rs_' ),
				'id'    => "{$prefix}whypoint2",
				'type'  => 'text',
			),
            array(
				'name'  => __( 'whypoint3', 'rs_' ),
				'id'    => "{$prefix}whypoint3",
				'type'  => 'text',
			),
            array(
				'name'  => __( 'whypoint4', 'rs_' ),
				'id'    => "{$prefix}whypoint4",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'whypoint5', 'rs_' ),
				'id'    => "{$prefix}whypoint5",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'whypoint6', 'rs_' ),
				'id'    => "{$prefix}whypoint6",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'whypoint7', 'rs_' ),
				'id'    => "{$prefix}whypoint7",
				'type'  => 'text',
			),
			//array(
				//'name'             => __( 'Date', 'rs_' ),
				//'id'               => "{$asdfix}date",
				//'type'             => 'text',
			//),
			
			
			
		)
	);
    
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'standard',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Standard Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('features'),
		
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// Special Content
			array(
				'name'  => __( 'Icon', 'rs_' ),
				'id'    => "{$prefix}icon",
				'type'  => 'text',
			),
			
			
			
			
		)
	);
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'socialicons',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Socialicons Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('socialicons'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// TEXT
			array(
				'name'  => __( 'Icon', 'rs_' ),
				'id'    => "{$prefix}icon",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'Link', 'rs_' ),
				'id'    => "{$prefix}link",
				'type'  => 'text',
			),
			
			
		)
	);
	
	
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'team',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Team Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('team'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// TEXT
			array(
				'name'  => __( 'Designation', 'rs_' ),
				'id'    => "{$prefix}designation",
				'type'  => 'text',
			),
			
			
		)
	);
	
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'process',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Process Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('process'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// TEXT
			array(
				'name'  => __( 'Icon', 'rs_' ),
				'id'    => "{$prefix}icon",
				'type'  => 'text',
			),
			
			
		)
	);
	$meta_boxes[] = array(
		// Meta box id, UNIQUE per meta box. Optional since 4.1.5
		'id'         => 'standard',
		// Meta box title - Will appear at the drag and drop handle bar. Required.
		'title'      => __( 'Standard Fields', 'rs_' ),
		// Post types, accept custom post types as well - DEFAULT is 'post'. Can be array (multiple post types) or string (1 post type). Optional.
		'post_types' => array('packages'),
		// Where the meta box appear: normal (default), advanced, side. Optional.
		'context'    => 'normal',
		// Order of meta box: high (default), low. Optional.
		'priority'   => 'high',
		// Auto save: true, false (default). Optional.
		'autosave'   => true,
		// List of meta fields
		'fields'     => array(
			// Special Content
			array(
				'name'  => __( 'price', 'rs_' ),
				'id'    => "{$prefix}price",
				'type'  => 'text',
			),
            array(
				'name'  => __( 'speed', 'rs_' ),
				'id'    => "{$prefix}speed",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'feature1', 'rs_' ),
				'id'    => "{$prefix}feature1",
				'type'  => 'text',
			),
            array(
				'name'  => __( 'feature2', 'rs_' ),
				'id'    => "{$prefix}feature2",
				'type'  => 'text',
			),
			array(
				'name'  => __( 'feature3', 'rs_' ),
				'id'    => "{$prefix}feature3",
				'type'  => 'text',
			),
            
			
			
			
			
		)
	);
	return $meta_boxes;
}
